// vkloader.cpp : Defines the initialization routines for the DLL.
// (c)  , telepat@inbox.ru
#include "stdafx.h"
#include <afxdllx.h>
#include "../_common/addin/addin.hpp"
#include "../_common/contextimpl.hpp"
#include "../_common/traps.hpp"

CTrapSwap trap;

static AFX_EXTENSION_MODULE VkloaderDLL = { NULL, NULL };

BOOL AFXAPI WrapAfxOleCanExitApp(){return TRUE;	}

class CAddin
{
protected:
	CAddin(){}
	BOOL InitAddin(IDispatch* pConn)
	{
		context_obj::CContextBase::InitAllContextClasses();
		trap.SetTrapOnImportFunc(AfxOleCanExitApp, WrapAfxOleCanExitApp);
		return TRUE;
	}
	void DoneAddin()
	{
		context_obj::CContextBase::DoneAllContextClasses();
	}
};

class __declspec(uuid("95991250-3ed2-4b9e-9d2b-b5a3ad80b61e")) CAddin;

extern "C"
int APIENTRY DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		DisableThreadLibraryCalls(hInstance);
		if (!AfxInitExtensionModule(VkloaderDLL, hInstance))
			return 0;
		new CDynLinkLibrary(VkloaderDLL);
		Init1CGlobal();
		addin::COneAddinImpl<CAddin>::OnProcessAttach();
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		AfxTermExtensionModule(VkloaderDLL);
		addin::COneAddinImpl<CAddin>::OnProcessDetach();
	}
	return 1;
}
