// traps.hpp
/*
(c)   telepat@inbox.ru
    .
*/
#pragma once

//        
class CTrapVirtual
{
public:
	CTrapVirtual():	m_pVtable(NULL), m_dwRealAdress(0){}
	~CTrapVirtual(){UnTrap();}
	
	//  .
	//      ,     ,
	//    ,    .
	//     .       .
	template<typename T>
	void SetTrap(void* pObject, int offset, T pFunc)
	{
		_SetTrap(pObject, offset, *reinterpret_cast<DWORD*>(&pFunc));
	}

	template<typename T>
	void GetAddress(T& t){t=*reinterpret_cast<T*>(&m_dwRealAdress);}
	
	//  .
	void UnTrap()
	{
		if(m_pVtable)
		{
			*m_pVtable=m_dwRealAdress;
			m_pVtable=NULL;
		}
	}

	void _SetTrap(void* pObject, int offset, DWORD dwFunction)
	{
		m_pVtable =*reinterpret_cast<DWORD**>(pObject);
		m_pVtable+=offset;
		DWORD old;
		VirtualProtect(m_pVtable,4,PAGE_EXECUTE_READWRITE,&old);
		m_dwRealAdress=*m_pVtable;
		*m_pVtable=dwFunction;
	}
	DWORD* m_pVtable;
	DWORD  m_dwRealAdress;
};

typedef unsigned __int64 ui64;

//          .
class CTrapSwap
{
public:
	CTrapSwap():m_pFunc(NULL), m_SwapBuf(0){}

	template<typename T>
	void SetTrapByName(HINSTANCE hDll, LPCSTR strFuncName, T newFunc)
	{
		DWORD* pFunc=reinterpret_cast<DWORD*>(GetProcAddress(hDll, strFuncName));
		DWORD pNewFunc=*reinterpret_cast<DWORD*>(&newFunc);
		_SetTrap(pFunc, pNewFunc);
	}
	
	template<typename T>
	void SetTrapByName(LPCSTR strDll, LPCSTR strFuncName, T newFunc)
	{
		SetTrapByName(GetModuleHandle(strDll), strFuncName, newFunc);
	}

	template<typename T, typename M>
	void SetTrapOnImportFunc(T oldFunc, M newFunc)
	{
		BYTE* ptr=*reinterpret_cast<BYTE**>(&oldFunc);
		ptr+=2;
		DWORD* pFunc=**reinterpret_cast<DWORD***>(ptr);
		DWORD pNewFunc=*reinterpret_cast<DWORD*>(&newFunc);
		_SetTrap(pFunc, pNewFunc);
	}

	void Swap()
	{
		ui64 t=*m_pFunc;
		*m_pFunc=m_SwapBuf;
		m_SwapBuf=t;
	}
	ui64* m_pFunc;
protected:
	ui64 m_SwapBuf;
	void _SetTrap(DWORD* pFunc, DWORD pNewFunc)
	{
		m_pFunc=reinterpret_cast<ui64*>(pFunc);
		DWORD old;
		VirtualProtect(pFunc, 8, PAGE_EXECUTE_READWRITE, &old);
		//      
		m_SwapBuf = (static_cast<ui64>(pNewFunc - reinterpret_cast<DWORD>(pFunc)-5)<<8) | 0xE9;
		//       
		Swap();
	}
};


struct trapswaper
{
	CTrapSwap& trap;
	trapswaper(CTrapSwap& t):trap(t){trap.Swap();}
	~trapswaper(){trap.Swap();}
};